# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("SDM Tools")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Edge Tool")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Face Tool")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("CorG Tool")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Misc Tool")
end
unless file_loaded?(__FILE__)
	sub=$sdm_Misc_tools.add_item("Random Cubes") { SDM::Random_Cubes.by_faces }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
require 'Sketchup'
#
module SDM

	module Random_Cubes

		def self.by_faces

			mod = Sketchup.active_model
			ent = mod.entities
			sel = mod.selection
			vals=UI.inputbox(["Cube Size:","Cube Text:","Text Hgt:"],[2,"DNS",60],"Auto Cube")
			if vals
				mod.start_operation "Select By Faces"
				dxy=vals[0];txt=vals[1];hgt=vals[2];st=Time.now
				tgrp=ent.add_group;tge=tgrp.entities
				tge.add_3d_text(txt,1,"Arial",false,false,hgt,0,0,true,0)
				faces = tge.grep(Sketchup::Face)
				fx = tgrp.bounds.width*1.2; fy = tgrp.bounds.height*1.2
				ctr = Geom::Point3d.new(fx/2,fy/2,dxy*8)
				trn = Geom::Transformation.new(ctr-tgrp.bounds.center)
				tgrp.transform! trn;tgt=tgrp.transformation
				0.step(fx,dxy){|x|
					0.step(fy,dxy){|y|
						fgrp=ent.add_group;fge=fgrp.entities;fgt=fgrp.transformation
						f=fge.add_face([x,y,0],[x,y+dxy,0],[x+dxy,y+dxy,0],[x+dxy,y,0])
						fc = Geom::Point3d.new(x+dxy/2,y+dxy/2,0);
						fc.transform! tgt.inverse; hit=false
						for tf in faces
							pp = fc.project_to_plane tf.plane
							if [1,2,4].include?(tf.classify_point(pp))
								hit=true;break
							end
						end
						if hit
							begin scl=rand(7) end until scl>3
							f.back_material=f.material='red'
						else
							begin scl=rand(4) end until scl>0
							f.back_material=f.material='blue'
						end
						f.pushpull -dxy*scl;fgrp.explode
					}
				}
				tgrp.erase!;puts "Completed in #{Time.now-st} seconds"
			end
			mod.commit_operation
		end
		
	end#module

end

